package ArrayListPlay;

import java.util.Scanner;
import java.util.ArrayList;

/**
 * ArrayListPlay - Play with collections of Date objects
 *
 * @author David
 * @version 1.00 2012/11/29
 */

public class ArrayListPlay
{
    public static void main( String[] args)
	{
    	Scanner scan = new Scanner( System.in);

    	System.out.println( "Start of ArrayListPlay\n");

		// VARIABLES
		ArrayList<Date>	list;
//		ArrayList<Object>	list;

		// PROGRAM CODE
		list = new ArrayList<Date>();
//		list = new ArrayList<Object>();

		// empty list...
		System.out.println( list);

		// add a bunch of dates to the list...
		list.add( new Date() );
		list.add( new Date( 1, 1, 1970) );
		list.add( new Date( 25, 12, 2000) );
		list.add( new Date( 1, 3, 2005) );

		System.out.println( list);
		System.out.println( "List has " + list.size() + " elements." );


		// remove one...
		list.remove( 1);
		System.out.println( list);

		// add another at index 0...
		list.add( 0, new Date( 31, 3, 1999) );
		System.out.println( list);

		// change last one...
		list.set( list.size()-1, new Date(15, 3, 2012) );
		System.out.println( list);
		System.out.println();

		// print out one by one...
		for ( int i = 0; i < list.size(); i++)
		{
			Object o = list.get(i);
			Date d = (Date) o;					// typecast since may contain any Object
			System.out.println( d.getAge() );
		}
		System.out.println();

		// add String & demo exception...
//		list.add( "OOPS!");

//		for ( int i = 0; i < list.size(); i++)
//		{
//			Object o = list.get(i);
//			Date d = (Date) o;					// typecast fails since String not Date
//			System.out.println( d.getAge() );
//		}
//		System.out.println();

		// resolve by checking type...?   Use very sparingly!
		for ( int i = 0; i < list.size(); i++)
		{
			Object o = list.get(i);
			if ( o instanceof Date)
			{
				Date d = (Date) o;
				System.out.println( d.getAge() );
			}
		}
		System.out.println();

		
//
//		// can also print out one-by-one using alternative for syntax
//		for ( Date d : list )
//		{
//			System.out.println( d );
//		}
//		System.out.println();

		// demo indexOf (similarly contains & maybe compareTo?)
		// note that following does not work correctly unless
		// equals method is properly defined in Date class!
		// -as "boolean equals( Object o)" not "boolean equals( Date d)"
		System.out.println( "indexOf " + list.indexOf( new Date( 25, 12, 2000) ) );
		System.out.println( list);

		System.out.println( "\nEnd of ArrayListPlay\n" );
	}

} // end of class ArrayListPlay
